#include <pthread.h>
#include "Pkt.h"

/* #pragma init(Pktinit) */

Arr *PktTypes = 0 ;

static void 
Pkt_init()
{
    int i ; 
    PacketType *atype ;

    PktTypes = newarr(0) ;
    for(i=0 ; i<nPktList ; i++ ) {
	atype = PktList+i ; 
	if ( *(atype->name) != 0 ) { 
	    setarr(PktTypes, atype->name, atype) ; 
	}
    }
}

PktChannel *
newPktChannel ()
{
    PktChannel *achan ; 
    allot (PktChannel *, achan, 1) ;
    memset((char *) achan, 0, sizeof(*achan)) ;
    achan->calper = -1.0 ; 
    achan->data = 0 ; 
    achan->isfloat = 0 ; 
    achan->datasz = 0 ;
    achan->hook = 0 ;
    return achan ;
}

Packet *
newPkt ()
{
    Packet *pkt ;
    allot (Packet *, pkt, 1) ;
    memset(pkt, 0, sizeof(Packet)) ;
    pkt->channels = newtbl(0) ;
    pkt->db = dbinvalid() ; 
    return pkt ;
}

void 
clrPktChannel ( PktChannel *achan ) 
{
    int *data, datasz ;
    data = achan->data ;
    datasz = achan->datasz ;
    memset((char *) achan, 0, sizeof(*achan)) ;
    achan->calper = -1.0 ;
    achan->segtype[0] = '-' ;
    achan->data = data ;
    achan->isfloat = 0 ; 
    achan->datasz = datasz ;
}

void 
clrPkt ( Packet *pkt ) 
{
    int i, n ; 
    pkt->version = 0 ;
    pkt->nchannels = 0 ;
    n = maxtbl(pkt->channels) ; 
    for ( i=0 ; i<n ; i++ ) {
	clrPktChannel((PktChannel *)gettbl(pkt->channels, i) ) ; 
    }
    if ( pkt->pf != 0) {
	pffree(pkt->pf) ; 
	pkt->pf = 0 ; 
    }
    if ( pkt->string != 0) {
	free(pkt->string) ; 
	pkt->string = 0 ; 
	pkt->string_size = 0 ; 
    }
    pkt->db = dbinvalid() ; 
}


void 
freePktChannel( PktChannel *achan) 
{
    if( achan->data != NULL ) 
	free( achan->data );
    if ( achan->hook != 0 ) { 
	free_hook ( &achan->hook ) ; 
    }
    free( (void *) achan );
}

void 
freePkt( Packet *Pkt)
{
    freetbl( Pkt->channels, (void (*)(void *))freePktChannel );
    if ( Pkt->pf != 0 ) { 
	pffree(Pkt->pf) ; 
    }
    if ( Pkt->string != 0 ) { 
	free(Pkt->string) ; 
    }
    if ( Pkt->dfile != 0 ) { 
	free(Pkt->dfile) ; 
    }
    if ( Pkt->pkthook != 0 ) { 
	free_hook ( &Pkt->pkthook ) ; 
    }
    if (Pkt->cbuf != 0) { 
	free(Pkt->cbuf) ; 
    }
    free( (void *) Pkt );
}


void 
join_srcname (Srcname *parts, char *srcname ) 
{
    char *in, *out ;
    int cnt = 0, len = 0  ; 
    out = srcname ;

    if ( *parts->src_net != 0 ) {
	in = parts->src_net ;
	while(*in != 0 ) {
	    *out++ = *in++ ; 
	    len++ ; 
	}
    }

    if ( *parts->src_sta != 0 ) {
	in = parts->src_sta ;
	while ( cnt < 1) { 
	    *out++ = '_' ;
	    cnt++ ;
	    len++ ; 
	}
	while(*in != 0 && len < ORBSRCNAME_SIZE-2) {
	    *out++ = *in++ ; 
	    len++ ; 
	}
    }

    if ( *parts->src_chan != 0 ) {
	in = parts->src_chan ;
	while ( cnt < 2&& len < ORBSRCNAME_SIZE-2) { 
	    *out++ = '_' ;
	    cnt++ ;
	    len++ ; 
	}
	while(*in != 0 && len < ORBSRCNAME_SIZE-2) {
	    *out++ = *in++ ; 
	    len++ ; 
	}
    }

    if ( *parts->src_loc != 0 ) {
	in = parts->src_loc ;
	while ( cnt < 3&& len < ORBSRCNAME_SIZE-2) { 
	    *out++ = '_' ;
	    cnt++ ;
	    len++ ; 
	}
	while(*in != 0 && len < ORBSRCNAME_SIZE-2) {
	    *out++ = *in++ ; 
	    len++ ; 
	}
    }

    if ( *parts->src_suffix != 0 && len < ORBSRCNAME_SIZE-2) {
	in = parts->src_suffix ;
	*out++ = '/' ;
	len++ ;
	while(*in != 0 && len < ORBSRCNAME_SIZE-2) {
	    *out++ = *in++ ; 
	    len++ ; 
	}
    }

    if ( *parts->src_subcode != 0 ) {
	in = parts->src_subcode ;
	*out++ = '/' ;
	len++ ; 
	while(*in != 0 && len < ORBSRCNAME_SIZE-2) {
	    *out++ = *in++ ; 
	    len++ ; 
	}
    }
    *out = 0 ;
}


void 
split_srcname ( char *srcname, Srcname *parts ) 
{
    int i ; 
    char *out ;

    out = (char *) &parts->src_net ;
    for (i=0 ; *srcname != 0 && i<PKT_TYPESIZE-1 ; i++ ) {
	if (*srcname=='_' || *srcname == '/') {
	    break ;
	}
	*out++ = *srcname++ ; 
    }
    *out = 0 ; 

    out = (char *) &parts->src_sta ;
    if ( *srcname == '_' ) { 
	srcname++ ;
	for (i=0 ; *srcname != 0 && i<PKT_TYPESIZE-1 ; i++ ) {
	    if (*srcname=='_'||*srcname=='/') {
		break ;
	    }
	    *out++ = *srcname++ ; 
	}
    }
    *out = 0 ; 

    out = (char *) &parts->src_chan ;
    if ( *srcname == '_' ) { 
	srcname ++ ;
	for (i=0 ; *srcname != 0 && i<PKT_TYPESIZE-1 ; i++ ) {
	    if (*srcname=='_'||*srcname=='/') {
		break ;
	    }
	    *out++ = *srcname++ ; 
	}
    }
    *out = 0 ; 

    out = (char *) &parts->src_loc ;
    if ( *srcname == '_' ) { 
	srcname ++ ;
	for (i=0 ; *srcname != 0 && i<PKT_TYPESIZE-1 ; i++ ) {
	    if (*srcname=='/') {
		break ;
	    }
	    *out++ = *srcname++ ; 
	}
    }
    *out = 0 ; 

    if (*srcname == '/' ) {
	srcname++ ; 
    }

    out = (char *) &parts->src_suffix ;
    for (i=0 ; *srcname != 0 && i<PKT_TYPESIZE-1 ; i++ ) {
	if (*srcname=='/') {
	    srcname++ ;
	    break ;
	}
	*out++ = *srcname++ ; 
    }
    *out = 0 ; 

    out = (char *) &parts->src_subcode ;
    for (i=0 ; *srcname != 0 && i<PKT_TYPESIZE-1 ; i++ ) {
	if (*srcname=='/') {
	    srcname++ ;
	    break ;
	}
	*out++ = *srcname++ ; 
    }
    *out = 0 ; 

}

PacketType *
header2pkttype ( short hdrcode, short bodycode ) 
{
    int i ;
    PacketType *pkttype = 0;
    PacketType *atype ;

    for(i=0 ; i<nPktList ; i++ ) {
	atype = PktList+i ; 
	if ( atype->hdrcode == hdrcode && atype->bodycode == bodycode ) { 
	    pkttype = atype ; 
	    break ;
	}
    }
    return pkttype ; 
}

PacketType *
suffix2pkttype (char *suffix) 
{
    static pthread_mutex_t last_mutex = PTHREAD_MUTEX_INITIALIZER ;
    static PacketType *last_pkttype = 0;
    PacketType *pkttype = 0;

    pthread_mutex_lock(&last_mutex ) ;

    if ( last_pkttype != 0 && strcmp(suffix, last_pkttype->suffix) == 0 ) {
	pkttype = last_pkttype ;
    } else {
	if ( PktTypes == 0 ) { 
	    Pkt_init() ; 
	}
	pkttype = (PacketType *) getarr(PktTypes, suffix) ; 
	if ( pkttype != 0 ) { 
	    last_pkttype = pkttype ;
	}
    }
    pthread_mutex_unlock(&last_mutex ) ; 
    return pkttype ;
}

Tbl *
pktsuffixes (int content)
{
    PacketType *atype = 0;
    Tbl *list ;
    int i ; 
    list = newtbl(20) ; 
    for(i=0 ; i<nPktList ; i++ ) {
	atype = PktList+i ; 
	if ( atype->content == content) { 
	    pushtbl(list, atype->suffix) ;
	}
    }
    return list ; 
}

int 
unstuffPkt(  char *srcname, double time, char *packet, int nbytes, 
	Packet **pktp  ) 
{
    Packet *pkt ;
    PacketType *pkttype ;
    int result = 0 ;
    int hdrcode=0, bodycode=0 ; 
    char *s ;

    if ( *pktp == 0 ) { 
	*pktp = pkt = newPkt() ; 
    } else { 
	pkt = *pktp ; 
    }
    clrPkt ( pkt ) ; 

    pkt->time = time ;
    split_srcname ( srcname, &(pkt->parts) ) ;
    if ( *(pkt->parts.src_suffix) == 0 ) {
	if ( nbytes > 6 ) {
	    NS2HI(&hdrcode, packet+4, 1) ;
	    NS2HI(&bodycode, packet+6, 1) ;
	    pkt->pkttype = pkttype = 
		header2pkttype (hdrcode, bodycode) ;
	} else { 
	    pkt->pkttype = pkttype = 0 ; 
	}
    } else {
	pkt->pkttype = pkttype = 
	    suffix2pkttype (pkt->parts.src_suffix) ;
    }

    if ( nbytes == 0 ) { 
	result = -1 ; 
    } else if ( is_stash(srcname, packet, nbytes) ) { 
	AllocBuffer in, out ; 
	in.data = (unsigned char *) packet+STASH_LENGTH ; 
	in.ndata = nbytes-STASH_LENGTH ; 
	in.allocated_size = 0 ; 
	out.data = pkt->cbuf ; 
	out.ndata = pkt->cbuf_nbytes ; 
	out.allocated_size = pkt->cbuf_size ; 
	result = btexpand ( &in, &out ) ;
	switch (result) { 
	    case 0:  // expanded
		result = Pkt_stash ; 
		pkt->cbuf = out.data ; 
		pkt->cbuf_nbytes = out.ndata ; 
		pkt->cbuf_size = out.allocated_size ; 
		allot ( char *, pkt->string, pkt->cbuf_nbytes) ; 
		memcpy ( pkt->string, pkt->cbuf, pkt->cbuf_nbytes ) ; 
		pkt->string_size = pkt->cbuf_nbytes ; 
		pkt->string[pkt->string_size-1] = 0 ; 
		break; 
	    case 1:  // not compressed 
		result = Pkt_stash ; 
		if ( nbytes > 0 ) { 
		    pkt->string_size = nbytes+1-STASH_LENGTH ;
		    allot ( char *, pkt->string, pkt->string_size) ;
		    memcpy ( pkt->string, packet+STASH_LENGTH, pkt->string_size-1 ) ;
		    pkt->string[pkt->string_size-1] = 0 ;
		} 
		break; 
	    default:  // uncompress failure 
		elog_log(0, "expansion failed for %d byte packet for %s at %s", 
			nbytes, srcname, s=strydtime(time)) ; 
		free(s) ; 
	}
    } else if ( pkttype != 0 ) { 
	AllocBuffer in, out ; 
	in.data = (unsigned char *) packet ; 
	in.ndata = nbytes ; 
	in.allocated_size = 0 ; 
	out.data = pkt->cbuf ; 
	out.ndata = pkt->cbuf_nbytes ; 
	out.allocated_size = pkt->cbuf_size ; 
	result = btexpand ( &in, &out ) ;
	switch (result) { 
	    case 0:  // expanded
		result = (pkttype->unstuff)(srcname, time, (char *)out.data, out.ndata, pkt) ;
		pkt->cbuf = out.data ; 
		pkt->cbuf_nbytes = out.ndata ; 
		pkt->cbuf_size = out.allocated_size ; 
		break; 
	    case 1:  // not compressed 
		result = (pkttype->unstuff)(srcname, time, (char *)in.data, in.ndata, pkt) ;
		break; 
	    default:  // uncompress failure 
		elog_log(0, "expansion failed for %d byte packet for %s at %s", 
			nbytes, srcname, s=strydtime(time)) ; 
		free(s) ; 
	}
    } else { 
	int           (*amethod)() ;
	amethod = (int (*)()) usermethod("unstuffPkt_User") ;
	if ( amethod != 0 ) {
	    result = amethod (srcname, time, packet, nbytes, pkt ) ;
	} else {
	    result = -1 ;
	}
    }
    if ( result == 0 ) { 
	if ( pkt->pkttype != 0 ) { 
	    result = pkt->pkttype->content ; 
	} else { 
	    result = -1 ; 
	}
    }
    return result ;
}

int 
stuffPkt(  Packet *pkt, 
	char *srcname, double *time, char **packet, int *nbytes, int *packetsz  ) 
{
    int result = 0 ;

    if ( pkt->pkttype != 0 ) { 
	result = (pkt->pkttype->stuff)(pkt, srcname, time, packet, nbytes, packetsz ) ;
	strcpy ( pkt->parts.src_suffix, pkt->pkttype->suffix ) ; 
	join_srcname ( &(pkt->parts), srcname) ; 
    } else { 
	int           (*amethod)() ;
	amethod = (int (*)()) usermethod("stuffPkt_User") ;
	if ( amethod != 0 ) {
	    result = amethod (pkt, srcname, time, packet, nbytes, packetsz ) ;
	    join_srcname ( &(pkt->parts), srcname) ; 
	} else {
	    result = -2 ; 
	}
    }
    if ( result >= 0 ) { 
	if ( pkt->pkttype != 0 ) { 
	    int compress_result ;
	    result = pkt->pkttype->content ; 
	    compress_result = pktcompress( pkt, (unsigned char **) packet, nbytes, packetsz)  ;
	    if (compress_result == -2) { 
		char *s ; 
		elog_complain(0, "inadequate compression for %d byte packet for %s at %s", 
			*nbytes, srcname, s=strydtime(*time) ) ; 
		free(s) ; 
	    } else if ( compress_result < 0 ) { 
		char *s ; 
		elog_complain(0, "compression failed for %d byte packet for %s at %s", 
			*nbytes, srcname, s=strydtime(*time) ) ; 
		free(s) ; 
	    }
	}
    }
    return result ;
}

int 
stuffStashPkt(  char *stash, int nstash, char **packet, int *nbytes, int *packetsz  ) 
{
    int compressed=0, retcode = 0 ;
    AllocBuffer in, out ; 
    if ( ok2compress() ) { 
	in.data = (unsigned char *) stash ; 
	in.ndata = nstash ; 
	in.allocated_size = 0 ; // shouldn't matter
	out.data = 0 ; 
	out.ndata = 0 ; 
	out.allocated_size = 0 ; 
	retcode = btcompress(&in, &out) ;
	if ( retcode == 0 ) { 
	    *nbytes = out.ndata + STASH_LENGTH ; 
	    RESIZE_BUFFER ( char *, *packet, *packetsz, *nbytes ) ;
	    strncpy ( *packet, STASH, STASH_LENGTH ) ; 
	    memcpy ( (*packet)+STASH_LENGTH, out.data, out.ndata ) ; 
	    compressed = 1 ; 
	    free(out.data) ; 
	}
    }
    if ( compressed == 0 ) { 
	*nbytes = nstash + STASH_LENGTH ; 
	RESIZE_BUFFER ( char *, *packet, *packetsz, *nbytes ) ;
	strncpy ( *packet, STASH, STASH_LENGTH ) ; 
	memcpy ( (*packet)+STASH_LENGTH, stash, nstash ) ; 
    }
    return Pkt_stash ; 
}
